<?xml version="1.0" encoding="iso-8859-1"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<!-- Source/Synopsis/Formatters/Dump.py.html -->
<!-- this view was generated by Source -->
<head>
<meta content="text/html; charset=iso-8859-1" http-equiv="Content-Type"/>
<title >Synopsis - Synopsis/Formatters/Dump.py</title>
<link href="../../../style.css" type="text/css" rel="stylesheet" />
</head>
<body class="Source">
<div class="navigation">
<span class="normal"><a href="../../../Scopes/Synopsis.html" >Global Package</a></span>
<span class="normal"><a href="../../../InheritanceTree.html" >Inheritance Tree</a></span>
<span class="normal"><a href="../../../InheritanceGraph.html" >Inheritance Graph</a></span>
<span class="normal"><a href="../../../NameIndex.html" >Name Index</a></span>
</div>
File: <b >Synopsis/Formatters/Dump.py</b><pre class="sxr"><a id="line1"></a><span class="lineno">  1</span><span class="line"><span class="py-comment">#</span></span>
<a id="line2"></a><span class="lineno">  2</span><span class="line"><span class="py-comment"># Copyright (C) 2003 Stefan Seefeld</span></span>
<a id="line3"></a><span class="lineno">  3</span><span class="line"><span class="py-comment"># All rights reserved.</span></span>
<a id="line4"></a><span class="lineno">  4</span><span class="line"><span class="py-comment"># Licensed to the public under the terms of the GNU LGPL (&gt;= 2),</span></span>
<a id="line5"></a><span class="lineno">  5</span><span class="line"><span class="py-comment"># see the file COPYING for details.</span></span>
<a id="line6"></a><span class="lineno">  6</span><span class="line"><span class="py-comment">#</span></span>
<a id="line7"></a><span class="lineno">  7</span>
<a id="line8"></a><span class="lineno">  8</span><span class="line"><span class="py-string">&quot;&quot;&quot;</span></span>
<a id="line9"></a><span class="lineno">  9</span><span class="line"><span class="py-string">Verbose attribute-oriented xml dump of ASG, useful for validation,</span></span>
<a id="line10"></a><span class="lineno"> 10</span><span class="line"><span class="py-string">introspection, and debugging.</span></span>
<a id="line11"></a><span class="lineno"> 11</span><span class="line"><span class="py-string">&quot;&quot;&quot;</span></span>
<a id="line12"></a><span class="lineno"> 12</span>
<a id="line13"></a><span class="lineno"> 13</span><span class="line"><span class="py-keyword">from</span> Synopsis <span class="py-keyword">import</span> config</span>
<a id="line14"></a><span class="lineno"> 14</span><span class="line"><span class="py-keyword">from</span> Synopsis.Processor <span class="py-keyword">import</span> *</span>
<a id="line15"></a><span class="lineno"> 15</span><span class="line"><span class="py-keyword">from</span> Synopsis.SourceFile <span class="py-keyword">import</span> SourceFile</span>
<a id="line16"></a><span class="lineno"> 16</span><span class="line"><span class="py-keyword">from</span> Synopsis.DocString <span class="py-keyword">import</span> DocString</span>
<a id="line17"></a><span class="lineno"> 17</span><span class="line"><span class="py-keyword">from</span> Synopsis.QualifiedName <span class="py-keyword">import</span> *</span>
<a id="line18"></a><span class="lineno"> 18</span>
<a id="line19"></a><span class="lineno"> 19</span><span class="line"><span class="py-keyword">import</span> sys, getopt, os, os.path, string, types</span>
<a id="line20"></a><span class="lineno"> 20</span><span class="line"><span class="py-keyword">from</span> xml.dom.minidom <span class="py-keyword">import</span> getDOMImplementation</span>
<a id="line21"></a><span class="lineno"> 21</span>
<a id="line22"></a><span class="lineno"> 22</span><span class="line">dom = getDOMImplementation().createDocument(None, <span class="py-string">'dump'</span>, None)</span>
<a id="line23"></a><span class="lineno"> 23</span>
<a id="line24"></a><span class="lineno"> 24</span><span class="line"><span class="py-keyword">class</span> <a href="../../../Scopes/Synopsis/Formatters/Dump/Formatter.html">Formatter</a>(Processor):</span>
<a id="line25"></a><span class="lineno"> 25</span>
<a id="line26"></a><span class="lineno"> 26</span><span class="line">    show_ids = Parameter(True, <span class="py-string">'output object ids as attributes'</span>)</span>
<a id="line27"></a><span class="lineno"> 27</span><span class="line">    show_declarations = Parameter(True, <span class="py-string">'output declarations'</span>)</span>
<a id="line28"></a><span class="lineno"> 28</span><span class="line">    show_types = Parameter(True, <span class="py-string">'output types'</span>)</span>
<a id="line29"></a><span class="lineno"> 29</span><span class="line">    show_files = Parameter(True, <span class="py-string">'output files'</span>)</span>
<a id="line30"></a><span class="lineno"> 30</span><span class="line">    stylesheet = Parameter(config.datadir + <span class="py-string">'/dump.css'</span>, <span class="py-string">'stylesheet to be referenced for rendering'</span>)</span>
<a id="line31"></a><span class="lineno"> 31</span>
<a id="line32"></a><span class="lineno"> 32</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Formatters/Dump/Formatter.html#process">process</a>(self, ir, **kwds):</span>
<a id="line33"></a><span class="lineno"> 33</span>
<a id="line34"></a><span class="lineno"> 34</span><span class="line">        self.set_parameters(kwds)</span>
<a id="line35"></a><span class="lineno"> 35</span><span class="line">        <span class="py-keyword">if</span> <span class="py-keyword">not</span> self.output: <span class="py-keyword">raise</span> MissingArgument(<span class="py-string">'output'</span>)</span>
<a id="line36"></a><span class="lineno"> 36</span><span class="line">        self.ir = self.merge_input(ir)</span>
<a id="line37"></a><span class="lineno"> 37</span>
<a id="line38"></a><span class="lineno"> 38</span><span class="line">        self.handlers = {type(None) : self.visit_none,</span>
<a id="line39"></a><span class="lineno"> 39</span><span class="line">                         type : self.visit_type,</span>
<a id="line40"></a><span class="lineno"> 40</span><span class="line">                         int : self.visit_string,</span>
<a id="line41"></a><span class="lineno"> 41</span><span class="line">                         long : self.visit_string,</span>
<a id="line42"></a><span class="lineno"> 42</span><span class="line">                         float : self.visit_string,</span>
<a id="line43"></a><span class="lineno"> 43</span><span class="line">                         str : self.visit_string,</span>
<a id="line44"></a><span class="lineno"> 44</span><span class="line">                         bool : self.visit_string,</span>
<a id="line45"></a><span class="lineno"> 45</span><span class="line">                         tuple : self.visit_tuple,</span>
<a id="line46"></a><span class="lineno"> 46</span><span class="line">                         list : self.visit_list,</span>
<a id="line47"></a><span class="lineno"> 47</span><span class="line">                         dict : self.visit_dict,</span>
<a id="line48"></a><span class="lineno"> 48</span><span class="line">                         types.InstanceType : self.visit_instance,</span>
<a id="line49"></a><span class="lineno"> 49</span><span class="line">                         QualifiedName : self.visit_string,</span>
<a id="line50"></a><span class="lineno"> 50</span><span class="line">                         QualifiedCxxName : self.visit_string,</span>
<a id="line51"></a><span class="lineno"> 51</span><span class="line">                         QualifiedPythonName : self.visit_string,</span>
<a id="line52"></a><span class="lineno"> 52</span><span class="line">                         SourceFile : self.visit_sourcefile,</span>
<a id="line53"></a><span class="lineno"> 53</span><span class="line">                         DocString : self.visit_docstring}</span>
<a id="line54"></a><span class="lineno"> 54</span><span class="line">        self.visited = []</span>
<a id="line55"></a><span class="lineno"> 55</span>
<a id="line56"></a><span class="lineno"> 56</span><span class="line">        self.os = open(self.output, <span class="py-string">'w'</span>)</span>
<a id="line57"></a><span class="lineno"> 57</span><span class="line">        self.os.write(<span class="py-string">'&lt;?xml version=&quot;1.0&quot; encoding=&quot;ISO-8859-1&quot;?&gt;\n'</span>)</span>
<a id="line58"></a><span class="lineno"> 58</span><span class="line">        <span class="py-keyword">if</span> self.stylesheet:</span>
<a id="line59"></a><span class="lineno"> 59</span><span class="line">            self.os.write(<span class="py-string">'&lt;?xml-stylesheet href=&quot;%s&quot; type=&quot;text/css&quot;?&gt;\n'</span>%self.stylesheet)</span>
<a id="line60"></a><span class="lineno"> 60</span>
<a id="line61"></a><span class="lineno"> 61</span><span class="line">        self.os.write(<span class="py-string">'&lt;ir&gt;\n'</span>)</span>
<a id="line62"></a><span class="lineno"> 62</span><span class="line">        self.os.write(<span class="py-string">'&lt;asg&gt;\n'</span>)</span>
<a id="line63"></a><span class="lineno"> 63</span>
<a id="line64"></a><span class="lineno"> 64</span><span class="line">        <span class="py-keyword">if</span> self.show_declarations:</span>
<a id="line65"></a><span class="lineno"> 65</span><span class="line">            self.write_declarations(self.ir.asg.declarations)</span>
<a id="line66"></a><span class="lineno"> 66</span>
<a id="line67"></a><span class="lineno"> 67</span><span class="line">        <span class="py-keyword">if</span> self.show_types:</span>
<a id="line68"></a><span class="lineno"> 68</span><span class="line">            self.write_types(self.ir.asg.types)</span>
<a id="line69"></a><span class="lineno"> 69</span><span class="line">        self.os.write(<span class="py-string">'&lt;/asg&gt;\n'</span>)</span>
<a id="line70"></a><span class="lineno"> 70</span>
<a id="line71"></a><span class="lineno"> 71</span><span class="line">        <span class="py-keyword">if</span> self.show_files:</span>
<a id="line72"></a><span class="lineno"> 72</span><span class="line">            self.write_files(self.ir.files)</span>
<a id="line73"></a><span class="lineno"> 73</span>
<a id="line74"></a><span class="lineno"> 74</span><span class="line">        self.os.write(<span class="py-string">'&lt;/ir&gt;\n'</span>)</span>
<a id="line75"></a><span class="lineno"> 75</span>
<a id="line76"></a><span class="lineno"> 76</span><span class="line">        <span class="py-keyword">return</span> self.ir</span>
<a id="line77"></a><span class="lineno"> 77</span>
<a id="line78"></a><span class="lineno"> 78</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Formatters/Dump/Formatter.html#push">push</a>(self, name):</span>
<a id="line79"></a><span class="lineno"> 79</span>
<a id="line80"></a><span class="lineno"> 80</span><span class="line">        element = dom.createElement(name)</span>
<a id="line81"></a><span class="lineno"> 81</span><span class="line">        self.node.appendChild(element)</span>
<a id="line82"></a><span class="lineno"> 82</span><span class="line">        self.node = element</span>
<a id="line83"></a><span class="lineno"> 83</span>
<a id="line84"></a><span class="lineno"> 84</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Formatters/Dump/Formatter.html#pop">pop</a>(self):</span>
<a id="line85"></a><span class="lineno"> 85</span>
<a id="line86"></a><span class="lineno"> 86</span><span class="line">        self.node = self.node.parentNode</span>
<a id="line87"></a><span class="lineno"> 87</span>
<a id="line88"></a><span class="lineno"> 88</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Formatters/Dump/Formatter.html#add_text">add_text</a>(self, text):</span>
<a id="line89"></a><span class="lineno"> 89</span>
<a id="line90"></a><span class="lineno"> 90</span><span class="line">        node = dom.createTextNode(text)</span>
<a id="line91"></a><span class="lineno"> 91</span><span class="line">        self.node.appendChild(node)</span>
<a id="line92"></a><span class="lineno"> 92</span>
<a id="line93"></a><span class="lineno"> 93</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Formatters/Dump/Formatter.html#visit">visit</a>(self, obj):</span>
<a id="line94"></a><span class="lineno"> 94</span><span class="line">        i,t = id(obj), type(obj)</span>
<a id="line95"></a><span class="lineno"> 95</span><span class="line">        <span class="py-keyword">if</span> i <span class="py-keyword">in</span> self.visited:</span>
<a id="line96"></a><span class="lineno"> 96</span><span class="line">            <span class="py-keyword">if</span> self.show_ids:</span>
<a id="line97"></a><span class="lineno"> 97</span><span class="line">                self.node.setAttribute(<span class="py-string">'xref'</span>, str(i))</span>
<a id="line98"></a><span class="lineno"> 98</span><span class="line">            <span class="py-keyword">return</span></span>
<a id="line99"></a><span class="lineno"> 99</span><span class="line">        <span class="py-keyword">if</span> self.handlers.has_key(t):</span>
<a id="line100"></a><span class="lineno">100</span><span class="line">            self.handlers[t](obj)</span>
<a id="line101"></a><span class="lineno">101</span><span class="line">        <span class="py-keyword">elif</span> issubclass(t, object):</span>
<a id="line102"></a><span class="lineno">102</span><span class="line">            self.visit_instance(obj)</span>
<a id="line103"></a><span class="lineno">103</span><span class="line">        <span class="py-keyword">else</span>:</span>
<a id="line104"></a><span class="lineno">104</span><span class="line">            <span class="py-keyword">print</span> <span class="py-string">'Unknown type %s for object: &quot;%s&quot;'</span>%(t,obj)</span>
<a id="line105"></a><span class="lineno">105</span>
<a id="line106"></a><span class="lineno">106</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Formatters/Dump/Formatter.html#visit_none">visit_none</a>(self, obj): <span class="py-keyword">pass</span></span>
<a id="line107"></a><span class="lineno">107</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Formatters/Dump/Formatter.html#visit_string">visit_string</a>(self, obj): self.add_text(str(obj))</span>
<a id="line108"></a><span class="lineno">108</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Formatters/Dump/Formatter.html#visit_type">visit_type</a>(self, obj): self.write(obj) <span class="py-comment"># where is that used ??</span></span>
<a id="line109"></a><span class="lineno">109</span>
<a id="line110"></a><span class="lineno">110</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Formatters/Dump/Formatter.html#visit_tuple">visit_tuple</a>(self, obj):</span>
<a id="line111"></a><span class="lineno">111</span>
<a id="line112"></a><span class="lineno">112</span><span class="line">        <span class="py-keyword">if</span> len(obj) == 0: <span class="py-keyword">return</span></span>
<a id="line113"></a><span class="lineno">113</span><span class="line">        <span class="py-keyword">for</span> i <span class="py-keyword">in</span> obj:</span>
<a id="line114"></a><span class="lineno">114</span><span class="line">            self.push(<span class="py-string">'item'</span>)</span>
<a id="line115"></a><span class="lineno">115</span><span class="line">            self.visit(i)</span>
<a id="line116"></a><span class="lineno">116</span><span class="line">            self.pop()</span>
<a id="line117"></a><span class="lineno">117</span>
<a id="line118"></a><span class="lineno">118</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Formatters/Dump/Formatter.html#visit_list">visit_list</a>(self, obj):</span>
<a id="line119"></a><span class="lineno">119</span>
<a id="line120"></a><span class="lineno">120</span><span class="line">        <span class="py-keyword">if</span> len(obj) == 0: <span class="py-keyword">return</span></span>
<a id="line121"></a><span class="lineno">121</span><span class="line">        <span class="py-keyword">for</span> i <span class="py-keyword">in</span> obj:</span>
<a id="line122"></a><span class="lineno">122</span><span class="line">            self.push(<span class="py-string">'item'</span>)</span>
<a id="line123"></a><span class="lineno">123</span><span class="line">            self.visit(i)</span>
<a id="line124"></a><span class="lineno">124</span><span class="line">            self.pop()</span>
<a id="line125"></a><span class="lineno">125</span>
<a id="line126"></a><span class="lineno">126</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Formatters/Dump/Formatter.html#visit_dict">visit_dict</a>(self, dict):</span>
<a id="line127"></a><span class="lineno">127</span>
<a id="line128"></a><span class="lineno">128</span><span class="line">        items = dict.items()</span>
<a id="line129"></a><span class="lineno">129</span><span class="line">        <span class="py-keyword">if</span> len(items) == 0: <span class="py-keyword">return</span></span>
<a id="line130"></a><span class="lineno">130</span><span class="line">        items.sort()</span>
<a id="line131"></a><span class="lineno">131</span><span class="line">        <span class="py-keyword">for</span> i <span class="py-keyword">in</span> items:</span>
<a id="line132"></a><span class="lineno">132</span><span class="line">            self.push(<span class="py-string">'key'</span>)</span>
<a id="line133"></a><span class="lineno">133</span><span class="line">            self.visit(i[0])</span>
<a id="line134"></a><span class="lineno">134</span><span class="line">            self.pop()</span>
<a id="line135"></a><span class="lineno">135</span><span class="line">            self.push(<span class="py-string">'value'</span>)</span>
<a id="line136"></a><span class="lineno">136</span><span class="line">            self.visit(i[1])</span>
<a id="line137"></a><span class="lineno">137</span><span class="line">            self.pop()</span>
<a id="line138"></a><span class="lineno">138</span>
<a id="line139"></a><span class="lineno">139</span>
<a id="line140"></a><span class="lineno">140</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Formatters/Dump/Formatter.html#visit_sourcefile">visit_sourcefile</a>(self, obj):</span>
<a id="line141"></a><span class="lineno">141</span>
<a id="line142"></a><span class="lineno">142</span><span class="line">        self.node.setAttribute(<span class="py-string">'name'</span>, obj.name)</span>
<a id="line143"></a><span class="lineno">143</span><span class="line">        self.node.setAttribute(<span class="py-string">'language'</span>, obj.annotations.get(<span class="py-string">'language'</span>, <span class="py-string">''</span>))</span>
<a id="line144"></a><span class="lineno">144</span><span class="line">        self.node.setAttribute(<span class="py-string">'primary'</span>, str(obj.annotations.get(<span class="py-string">'primary'</span>, False)))</span>
<a id="line145"></a><span class="lineno">145</span>
<a id="line146"></a><span class="lineno">146</span><span class="line">        includes = getattr(obj, <span class="py-string">'includes'</span>)</span>
<a id="line147"></a><span class="lineno">147</span><span class="line">        <span class="py-keyword">if</span> includes:</span>
<a id="line148"></a><span class="lineno">148</span><span class="line">            self.push(<span class="py-string">'includes'</span>)</span>
<a id="line149"></a><span class="lineno">149</span><span class="line">            self.visit(includes)</span>
<a id="line150"></a><span class="lineno">150</span><span class="line">            self.pop()</span>
<a id="line151"></a><span class="lineno">151</span>
<a id="line152"></a><span class="lineno">152</span><span class="line">        <span class="py-keyword">if</span> self.show_declarations:</span>
<a id="line153"></a><span class="lineno">153</span><span class="line">            <span class="py-keyword">for</span> name <span class="py-keyword">in</span> [<span class="py-string">'declarations'</span>, <span class="py-string">'macro_calls'</span>]:</span>
<a id="line154"></a><span class="lineno">154</span><span class="line">                self.push(name)</span>
<a id="line155"></a><span class="lineno">155</span><span class="line">                self.visit(getattr(obj, name))</span>
<a id="line156"></a><span class="lineno">156</span><span class="line">                self.pop()</span>
<a id="line157"></a><span class="lineno">157</span>
<a id="line158"></a><span class="lineno">158</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Formatters/Dump/Formatter.html#visit_docstring">visit_docstring</a>(self, obj):</span>
<a id="line159"></a><span class="lineno">159</span>
<a id="line160"></a><span class="lineno">160</span><span class="line">        self.node.setAttribute(<span class="py-string">'markup'</span>, obj.markup)</span>
<a id="line161"></a><span class="lineno">161</span><span class="line">        self.push(<span class="py-string">'text'</span>)</span>
<a id="line162"></a><span class="lineno">162</span><span class="line">        self.visit(obj.text)</span>
<a id="line163"></a><span class="lineno">163</span><span class="line">        self.pop()</span>
<a id="line164"></a><span class="lineno">164</span>
<a id="line165"></a><span class="lineno">165</span>
<a id="line166"></a><span class="lineno">166</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Formatters/Dump/Formatter.html#visit_instance">visit_instance</a>(self, obj):</span>
<a id="line167"></a><span class="lineno">167</span><span class="line">        self.visited.append(id(obj))</span>
<a id="line168"></a><span class="lineno">168</span><span class="line">        self.push(<span class="py-string">'instance'</span>)</span>
<a id="line169"></a><span class="lineno">169</span><span class="line">        self.node.setAttribute(<span class="py-string">'class'</span>, <span class="py-string">'%s.%s'</span>%(obj.__class__.__module__,obj.__class__.__name__))</span>
<a id="line170"></a><span class="lineno">170</span><span class="line">        <span class="py-keyword">if</span> self.show_ids:</span>
<a id="line171"></a><span class="lineno">171</span><span class="line">            self.node.setAttribute(<span class="py-string">'id'</span>, str(id(obj)))</span>
<a id="line172"></a><span class="lineno">172</span><span class="line">        <span class="py-keyword">if</span> self.handlers.has_key(obj.__class__):</span>
<a id="line173"></a><span class="lineno">173</span><span class="line">            self.handlers[obj.__class__](obj)</span>
<a id="line174"></a><span class="lineno">174</span><span class="line">        <span class="py-keyword">else</span>:</span>
<a id="line175"></a><span class="lineno">175</span><span class="line">            attrs = obj.__dict__.items()</span>
<a id="line176"></a><span class="lineno">176</span><span class="line">            attrs.sort()</span>
<a id="line177"></a><span class="lineno">177</span><span class="line">            <span class="py-keyword">for</span> name, value <span class="py-keyword">in</span> attrs:</span>
<a id="line178"></a><span class="lineno">178</span><span class="line">                <span class="py-comment"># ignore None values</span></span>
<a id="line179"></a><span class="lineno">179</span><span class="line">                <span class="py-keyword">if</span> value <span class="py-keyword">in</span> (None, [], ()):</span>
<a id="line180"></a><span class="lineno">180</span><span class="line">                    <span class="py-keyword">continue</span></span>
<a id="line181"></a><span class="lineno">181</span><span class="line">                <span class="py-comment"># ignore private attributes</span></span>
<a id="line182"></a><span class="lineno">182</span><span class="line">                <span class="py-keyword">if</span> name[0] == <span class="py-string">'_'</span>:</span>
<a id="line183"></a><span class="lineno">183</span><span class="line">                    <span class="py-keyword">continue</span></span>
<a id="line184"></a><span class="lineno">184</span>
<a id="line185"></a><span class="lineno">185</span><span class="line">                <span class="py-comment"># String attributes map to xml attributes.</span></span>
<a id="line186"></a><span class="lineno">186</span><span class="line">                <span class="py-keyword">if</span> self.handlers.get(type(value)) == self.visit_string:</span>
<a id="line187"></a><span class="lineno">187</span><span class="line">                    self.node.setAttribute(name, str(value))</span>
<a id="line188"></a><span class="lineno">188</span><span class="line">                    <span class="py-comment"># Everything else maps to sub-elements.</span></span>
<a id="line189"></a><span class="lineno">189</span><span class="line">                <span class="py-keyword">else</span>:</span>
<a id="line190"></a><span class="lineno">190</span><span class="line">                    self.push(name)</span>
<a id="line191"></a><span class="lineno">191</span><span class="line">                    self.visit(value)</span>
<a id="line192"></a><span class="lineno">192</span><span class="line">                    self.pop()</span>
<a id="line193"></a><span class="lineno">193</span><span class="line">        self.pop()</span>
<a id="line194"></a><span class="lineno">194</span>
<a id="line195"></a><span class="lineno">195</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Formatters/Dump/Formatter.html#write_declarations">write_declarations</a>(self, declarations):</span>
<a id="line196"></a><span class="lineno">196</span>
<a id="line197"></a><span class="lineno">197</span><span class="line">        self.node = dom.createElement(<span class="py-string">'declarations'</span>)</span>
<a id="line198"></a><span class="lineno">198</span><span class="line">        <span class="py-keyword">for</span> d <span class="py-keyword">in</span> declarations:</span>
<a id="line199"></a><span class="lineno">199</span><span class="line">            self.push(<span class="py-string">'item'</span>)</span>
<a id="line200"></a><span class="lineno">200</span><span class="line">            self.visit(d)</span>
<a id="line201"></a><span class="lineno">201</span><span class="line">            self.pop()</span>
<a id="line202"></a><span class="lineno">202</span><span class="line">        self.node.writexml(self.os, indent=<span class="py-string">' '</span>, addindent=<span class="py-string">' '</span>, newl=<span class="py-string">'\n'</span>)</span>
<a id="line203"></a><span class="lineno">203</span><span class="line">        self.node.unlink()</span>
<a id="line204"></a><span class="lineno">204</span><span class="line">        <span class="py-keyword">del</span> self.node</span>
<a id="line205"></a><span class="lineno">205</span>
<a id="line206"></a><span class="lineno">206</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Formatters/Dump/Formatter.html#write_types">write_types</a>(self, types):</span>
<a id="line207"></a><span class="lineno">207</span>
<a id="line208"></a><span class="lineno">208</span><span class="line">        self.node = dom.createElement(<span class="py-string">'types'</span>)</span>
<a id="line209"></a><span class="lineno">209</span><span class="line">        values = types.values()</span>
<a id="line210"></a><span class="lineno">210</span><span class="line">        values.sort()</span>
<a id="line211"></a><span class="lineno">211</span><span class="line">        <span class="py-keyword">for</span> t <span class="py-keyword">in</span> values: self.visit(t)</span>
<a id="line212"></a><span class="lineno">212</span><span class="line">        self.node.writexml(self.os, indent=<span class="py-string">' '</span>, addindent=<span class="py-string">' '</span>, newl=<span class="py-string">'\n'</span>)</span>
<a id="line213"></a><span class="lineno">213</span><span class="line">        self.node.unlink()</span>
<a id="line214"></a><span class="lineno">214</span><span class="line">        <span class="py-keyword">del</span> self.node</span>
<a id="line215"></a><span class="lineno">215</span>
<a id="line216"></a><span class="lineno">216</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Formatters/Dump/Formatter.html#write_files">write_files</a>(self, files):</span>
<a id="line217"></a><span class="lineno">217</span>
<a id="line218"></a><span class="lineno">218</span><span class="line">        self.node = dom.createElement(<span class="py-string">'files'</span>)</span>
<a id="line219"></a><span class="lineno">219</span><span class="line">        <span class="py-keyword">for</span> f <span class="py-keyword">in</span> files: self.visit(files[f])</span>
<a id="line220"></a><span class="lineno">220</span><span class="line">        self.node.writexml(self.os, indent=<span class="py-string">' '</span>, addindent=<span class="py-string">' '</span>, newl=<span class="py-string">'\n'</span>)</span>
<a id="line221"></a><span class="lineno">221</span><span class="line">        self.node.unlink()</span>
<a id="line222"></a><span class="lineno">222</span><span class="line">        <span class="py-keyword">del</span> self.node</span>
<a id="line223"></a><span class="lineno">223</span>
<a id="line224"></a><span class="lineno">224</span>
</pre>
<div class="logo">Generated on Thu Apr 16 16:27:13 2009 by 
<br/>
<a href="http://synopsis.fresco.org" target="_blank"><img src="../../../synopsis.png" alt="logo"/> synopsis</a> (version devel)</div>
</body>
</html>
